import pygtk
pygtk.require('2.0')
import gtk.glade
import gobject
import os, sys, new, types

def find_datafile(filename):
    prefix = os.path.split(os.path.dirname(sys.argv[0]))[0]
    return os.path.join(prefix, 'share', 'xcurs', filename)

class GladeWidget:
    #if we are doing instance counting, this holds the variable
    num_instances = 0

    #This method loads the XML file and autoconnects the signals
    def initialize(self, glade_file, widget_name, autoclose=0):

        #initialize variables
        self.autoclose = autoclose
        self.widgets = gtk.glade.XML(find_datafile(glade_file), widget_name)
        callbacks = {}

        #find and store methods as bound callbacks
        class_methods = self.__class__.__dict__
        for method_name in class_methods.keys():
            if type(class_methods[method_name]) == types.FunctionType:
                callbacks[method_name] = new.instancemethod(class_methods[method_name], self, self.__class__)

        #autoconnect
        self.widgets.signal_autoconnect(callbacks)

        #instance counting
        if self.autoclose:
            GladeWidget.num_instances = GladeWidget.num_instances + 1

    #used so you can do self['WidgetName'], although I haven't
    # tested this yet
    def __getitem__(self, key):
        return self.widgets.get_widget(key)

    #for instance counting.  NOTE - does this work if a subclass
    #overrides __del__?  If so, should we just tell people not to do
    #that?
    def __del__(self):
        if self.autoclose:
            if GladeWidget.num_instances == 1: _gtk.main_quit()
            else: GladeWidget.num_instances = GladeWidget.num_instances - 1

